//* ****************************************************************** 
//* ORACLE CONFIDENTIAL.  For authorized use only.  Except for as      
//* expressly authorized by Oracle, do not disclose, copy, reproduce,  
//* distribute, or modify.                                             
//* ****************************************************************** 
//*                                                                    
/************************************************************************
 *                                                                      *
 *                                                                      *
 * Created by Tushar Chury 7/10                                         *
 *                                                                      *
 * Description - sdk_bus_exp.java                                       *
 *                                                                      *
 ************************************************************************/


package sdk_bus_exp; 
import java.io.*;
import java.util.*;
import psft.pt8.joa.*;
import java.math.*;
import PeopleSoft.Generated.CompIntfc.*;

public class sdk_bus_exp {
    /************************************************************************
     *       general defines and macros                                     *
     ***********************************************************************/
    
    //main menu selection Items  --- Choose Function
    private static final int SDK_BUS_EXP_Get                       =  1;
    private static final int SDK_BUS_EXP_Find                      =  2;
    private static final int SDK_BUS_EXP_SignOut                   =  3;
    
    //secondary menu selection Items   ---- Choose Method
    private static final int SDK_BUS_EXP_Save                      =  1;
    private static final int SDK_BUS_EXP_Cancel                    =  2;
    private static final int SDK_BUS_EXP_GetPropertyByName         =  3;
    private static final int SDK_BUS_EXP_GetPropertyInfoByName     =  4;
    private static final int SDK_BUS_EXP_InsertBusExpDtlDefaults   =  5;
    
    private static final int SDK_BUS_EXP_PER_GetPropertyByName     =  6;
    private static final int SDK_BUS_EXP_PER_GetPropertyInfoByName =  7;
    private static final int SDK_BUS_EXP_PER_Item                  =  8;
    private static final int SDK_BUS_EXP_PER_InsertItem            =  9;
    private static final int SDK_BUS_EXP_PER_DeleteItem            = 10;
    private static final int SDK_BUS_EXP_PER_ItemByKeys            = 11;
    private static final int SDK_BUS_EXP_PER_CurrentItem           = 12;
    private static final int SDK_BUS_EXP_PER_CurrentItemNum        = 13;
    private static final int SDK_BUS_EXP_PER_GetEffectiveItem      = 14;
    private static final int SDK_BUS_EXP_PER_GetEffectiveItemNum   = 15;
    
    private static final int SDK_BUS_EXP_DTL_GetPropertyByName     = 16;
    private static final int SDK_BUS_EXP_DTL_GetPropertyInfoByName = 17;
    private static final int SDK_BUS_EXP_DTL_Item                  = 18;
    private static final int SDK_BUS_EXP_DTL_InsertItem            = 19;
    private static final int SDK_BUS_EXP_DTL_DeleteItem            = 20;
    private static final int SDK_BUS_EXP_DTL_ItemByKeys            = 21;
    private static final int SDK_BUS_EXP_DTL_CurrentItem           = 22;
    private static final int SDK_BUS_EXP_DTL_CurrentItemNum        = 23;
    private static final int SDK_BUS_EXP_DTL_GetEffectiveItem      = 24;
    private static final int SDK_BUS_EXP_DTL_GetEffectiveItemNum   = 25;
    
    // SDK Business Expense Objects
    // one active period and one active detail record are possible at any time
    // the user will be promted to select the needed values if they are not active.
    private static String                                        m_strCIName;
    private static ISdkBusExpCollection                          oSdkBusExpCollection;
    private static ISdkBusExp                                    oSdkBusExp;
    private static ISdkBusExpSdkBusExpPerCollection              oSdkBusExpPerCollection;
    private static ISdkBusExpSdkBusExpPer                        oSdkBusExpPer;
    private static ISdkBusExpSdkBusExpPerSdkBusExpDtlCollection  oSdkBusExpDtlCollection;
    private static ISdkBusExpSdkBusExpPerSdkBusExpDtl            oSdkBusExpDtl;
    
    // Component Interface Property
    private static ICompIntfcPropertyInfo                        oCompIntfcPropertyInfo;
    private static ICompIntfcPropertyInfoCollection              oCompIntfcPropertyInfoCollection;
    
    public static class ciPropertyInfo {
        int     m_nLevel;
        String  m_PropertyName;
        boolean m_isCollection;

        ciPropertyInfo (int nLevel, String  PropertyName, boolean isCollection) {
            m_nLevel = nLevel;
            m_PropertyName = PropertyName;
            m_isCollection = isCollection;
        }        
    }

    static List m_ciMetaData = new ArrayList();
    
    /************************************************************************
     *       globals                                                        *
     ***********************************************************************/
    // Connect Parameters
    private static String    m_szAppServerPath;
    private static String    m_szServerName;
    private static String    m_szServerPort;
    private static String    m_szUserID;
    private static String    m_szUserPswd;
    private static boolean   m_bInteractiveMode  = false;
    private static boolean   m_bGetHistoryItems  = false;
    private static boolean   m_bEditHistoryItems = false;
    
    // Get Key variables
    private static String    m_szGET_EMPLID;
    
    // Find Key variables
    private static String    m_szFIND_EMPLID;
    private static String    m_szFIND_NAME;
    private static String    m_szFIND_LAST_NAME_SRCH;
    private static int       m_nFIND_EMPLID;
    private static int       m_nFIND_NAME;
    private static int       m_nFIND_LAST_NAME_SRCH;

    private static int       currentPeriod = 0;
    private static int       currentDetail = 0;

    // Connect Information
    static String m_strAppServerPath;
    static String m_strServerName;
    static String m_strServerPort;
    static String m_strUserID;
    static String m_strUserPswd;
    
    // PeopleSoft Session Object
    private static ISession oSession;
    
    static String strTemp;
    static int    nTemp;
    static BufferedReader inData = new BufferedReader(new InputStreamReader(System.in));
    
    /************************************************************************
     * Function:     readCharacter                                          *
     *                                                                      *
     * Description:  Reads a Character from the Standard input              *
     *                                                                      *
     * Returns:      char                                                   *
     ***********************************************************************/
    private static char readCharacter() {
        char readChar = ' ';
        String readStringC = "";
        readStringC = readLine();
        if (readStringC.length() > 0)
            readChar = readStringC.charAt(0);
        return readChar;
    }
    
    /************************************************************************
     * Function:     readLine                                               *
     *                                                                      *
     * Description:  reads a line from the standard input                   *
     *                                                                      *
     * Returns:      String                                                 *
     ***********************************************************************/
    private static String readLine() {
        String readString = "";
        try {
            readString = inData.readLine();
            System.out.println(" ");
        }
        catch (IOException e) {
            System.out.println("Error reading String from screen");
            e.printStackTrace();
        }
        return readString;
    }
    
    /************************************************************************
     * Function:     getIntValue                                            *
     *                                                                      *
     * Description:  returns an int from a string  0 if not valid.          *
     *                                                                      *
     * Returns:      int                                                    *
     ***********************************************************************/
    private static int getIntValue(String inString) {
        try {
            return Integer.parseInt(inString);
        }
        catch (NumberFormatException n) {
            System.out.println("Please enter a valid value");
            return 0;
        }
    }
    
    /************************************************************************
     * Function:     isQuit                                                 *
     *                                                                      *
     * Description:  Checks for q or Q at char{0) returns true if found     *
     *                                                                      *
     * Returns:      boolean                                                *
     ***********************************************************************/
    private static boolean isQuit(String stringIn) {
        return (stringIn.charAt(0) == 'q' || stringIn.charAt(0) == 'Q');
    }
    
    /************************************************************************
     * Function:     formatString                                           *
     *                                                                      *
     * Description:  Format String by padding spaces to the right           *
     *                                                                      *
     * Returns:      void                                                   *
     ***********************************************************************/
    private static String formatString(String inString, int fieldLength) {
        String outString = inString;
        for (int i=0; i < fieldLength - inString.length(); i++) {
            outString += " ";
        }
        return outString;
    }
    
    /************************************************************************
     * Function:     errorHandler                                           *
     *                                                                      *
     * Description:  Displays messages from the PSMessages object           *
     *                                                                      *
     * Returns:      void                                                   *
     ***********************************************************************/
    private static void errorHandler() {
        //***** Display PeopleSoft Error Messages *****
        if (oSession.getErrorPending() || oSession.getWarningPending()) {
            IPSMessageCollection oPSMessageCollection;
            IPSMessage oPSMessage;
            oPSMessageCollection = oSession.getPSMessages();
            for (int i = 0; i < oPSMessageCollection.getCount(); i++) {
                oPSMessage = oPSMessageCollection.item(i);
                if (oPSMessage != null) {
                    System.out.println("(" + oPSMessage.getMessageSetNumber() + "," 
                        + oPSMessage.getMessageSetNumber() + ") : " + oPSMessage.getText());
                }
            }
        }
    }
    
    /************************************************************************
     * Function:     init                                                   *
     *                                                                      *
     * Description:  Initialize default input values                        *
     *                                                                      *
     * Returns:      void                                                   *
     ***********************************************************************/
    private static void init() throws JOAException {
        //***** Default the Connect Variables *****
        m_strServerPort = "9000";
        m_strUserID = "PTDMO";
        m_strUserPswd = "PTDMO";
        m_strServerName = "";
        //***** Default the employee id *****
        m_szFIND_EMPLID = "8001";
        //***** Default the Component Interface Name *****
        m_strCIName = "SDK_BUS_EXP";
        System.out.println("PeopleSoft Component Interface Tester for Java");
    }
    
    /************************************************************************
     * Function:     setPSMode                                              *
     *                                                                      *
     * Description:  Set the mode for the Peoplesoft interactions           *
     *                                                                      *
     * Returns:      boolean   true if successful                           *
     ***********************************************************************/
    private static void setPSMode() {
        //get and set the mode values
        char charMode = ' ';
        //***** Prompt for InteractiveMode *****
        System.out.print("InteractiveMode (t/f) [f]: ");
        charMode = readCharacter();
        if (charMode == 't' || charMode == 'T')
            m_bInteractiveMode = true;
        //***** Prompt for GetHistoryItems *****
        System.out.print("GetHistoryItems (t/f) [f]: ");
        charMode = readCharacter();
        if (charMode == 't' || charMode == 'T')
            m_bGetHistoryItems = true;
        //***** Prompt for EditHistoryItems *****
        System.out.print("EditHistoryItems (t/f) [f]: ");
        charMode = readCharacter();
        if (charMode == 't' || charMode == 'T')
            m_bEditHistoryItems = true;
    }
    
    /************************************************************************
     * Function:     getKeyType                                             *
     *                                                                      *
     * Description:  Get Key Type - Get or Find                             *
     *                                                                      *
     * Returns:      boolean   true if successful                           *
     ***********************************************************************/
    private static boolean getKeyType() throws JOAException {
        String idKey = "";
        char charKeyType = ' ';
        int nOption = 0;
        int nReturn = 0;
        System.out.println("");
        System.out.println("------------------------------------------------------------");
        System.out.println("PeopleSoft SDK Business Expense for Java  - Choose Functions");
        System.out.println("------------------------------------------------------------");
        System.out.println("\t 1) Get");
        System.out.println("\t 2) Find");
        System.out.println("\t 3) Sign Out");
        System.out.println("\t q) Quit");
        System.out.println("");
        System.out.print("Command to execute (1-3, q) [q]: ");
        charKeyType = readCharacter();
        switch (charKeyType){
            case 'q':
            case 'Q':
                return false;
            case '1': {
                setPSMode();
                //***** Execute Get *****
                if (getGetKeys()) {
                    doGet();
                    return true;
                } else
                    return false;
            }
            case '2': {
                setPSMode();
                //***** Execute Find *****
                if  (doFind()) {
                    doGet();
                    return true;
                } else
                    return false;
            }
            case  '3' : {
                if (oSdkBusExp!= null){
                    System.out.println("Execute Cancel");
                    //***** Execute Cancel *****
                    oSdkBusExp.cancel();
                }
                return false;
            }
            default:
                return false;
        }
    }
    
    /************************************************************************
     * Function:     doFind                                                 *
     *                                                                      *
     * Description:  get search values from user, present possible values   *
     *                                                                      *
     * Returns:      boolean true if valid value, else false.               *
     ***********************************************************************/
    private static boolean doFind() throws JOAException {
        //***** Get the Find Keys *****
        if (!getFindKeys())
            return false;
        
        //***** Build the Find Keys *****
        buildFindKeys();
        
        //***** Get the Search Result *****
        if (!getFindResults())
            return false;
        
        System.out.println("Select Employee ID from this list.");
        System.out.print("Enter Employee ID: ");
        m_szGET_EMPLID = readLine();
        if (m_szGET_EMPLID.length()  > 0) {
            return true;
        } else {
            return false;
        }
    }
    
    /************************************************************************
     * Function:     doGet                                                  *
     *                                                                      *
     * Description:  get component interface instance from the server       *
     *                                                                      *
     * Returns:      Selected Method                                        *
     ***********************************************************************/
    private static void doGet() throws JOAException {
        //***** Execute Cancel *****
        oSdkBusExp.cancel();
        
        //***** Set Component Interface Get/Create Keys *****
        oSdkBusExp.setSdkEmplid(m_szGET_EMPLID);
        //***** Execute Get *****
        if (!oSdkBusExp.get()) {
            System.out.println("Failed to Get Component Interface " + m_strCIName);
            errorHandler();
            return;
        }
        //***** Get Level 0 fields *****
        System.out.println("Employee ID: " + m_szGET_EMPLID);
        strTemp = oSdkBusExp.getSdkName();
        System.out.println("Employee Name: " + strTemp);
        strTemp = oSdkBusExp.getSdkBirthdate();
        System.out.println("Employee Birtdate: " + strTemp);
        strTemp = oSdkBusExp.getSdkDeptid();
        System.out.println("Employee Department ID: " + strTemp);
        
        //***** Get the Business Expense Periods *****
        getSdkBusExpPer(oSdkBusExp, true);
    }
    
    /************************************************************************
     * Function:     selectMethod                                           *
     *                                                                      *
     * Description:  Select a Method                                        *
     *                                                                      *
     * Returns:      Selected Method                                        *
     ***********************************************************************/
    private static int selectMethod() throws JOAException {
        //***** Execute Cancel *****
        oSdkBusExp.cancel();
        
        //***** Set Component Interface Get/Create Keys *****
        oSdkBusExp.setSdkEmplid(m_szGET_EMPLID);
        
        //***** Execute Get *****
        if (!oSdkBusExp.get()) {
            System.out.println("Failed to Execute Get() at selectMethod() for Component Interface " + m_strCIName);
            System.out.println("Connection to server may be damaged.  Sign out and Sign in again");
            return 0;
        }
        oSdkBusExpPerCollection = oSdkBusExp.getSdkBusExpPer();
        if (currentPeriod > 0 && currentPeriod <= oSdkBusExpPerCollection.getCount()) {
            oSdkBusExpPer = oSdkBusExpPerCollection.item(currentPeriod - 1);
            oSdkBusExpDtlCollection = oSdkBusExpPer.getSdkBusExpDtl();
            if (currentDetail > 0 && currentDetail <= oSdkBusExpDtlCollection.getCount()) {
                oSdkBusExpDtl = oSdkBusExpDtlCollection.item(currentDetail - 1);
            } else {
                oSdkBusExpDtl = null;
            }
        }
        else {
            oSdkBusExpPer = null;
            oSdkBusExpDtl = null;
        }
        char charWork = ' ';
        String stringWork = "";
        int intWork = 0;
        if (oSdkBusExp == null)
            return 0;
        System.out.println("");
        System.out.println("---------------------------------------------------------");
        System.out.println("PeopleSoft SDK Business Expense for Java  - Select Method");
        System.out.println("---------------------------------------------------------");
        System.out.println("");
        System.out.println("Current active Employee is " + oSdkBusExp.getSdkName() 
            + " with employee number " + oSdkBusExp.getSdkEmplid() + "." );
        System.out.println("  SDK_BUS_EXP");
        System.out.println("  ===========");
        System.out.println("\t 1) Save                     2) Cancel");
        System.out.println("\t 3) GetPropertyByName        4) GetPropertyInfoByName");
        System.out.println("\t 5) InsertBusExpDtlDefaults");
        
        if (oSdkBusExpPer != null) {
            stringWork = "  SDK_BUS_EXP_PER   current active period number "
                + (oSdkBusExpPer.getItemNum() + 1)
                + " for period ending "
                + oSdkBusExpPer.getSdkExpPerDt();
        } else {
            stringWork = "  SDK_BUS_EXP_PER   current active period not initilized";
        }
        System.out.println(stringWork);
        System.out.println("  ===============");
        System.out.println("\t 6) GetPropertyByName        7) GetPropertyInfoByName");
        System.out.println("\t 8) Item                     9) InsertItem");
        System.out.println("\t10) DeleteItem              11) ItemByKeys");
        System.out.println("\t12) CurrentItem             13) CurrentItemNum");
        System.out.println("\t14) GetEffectiveItem        15) GetEffectiveItemNum");
        
        if (oSdkBusExpDtl != null) {
            stringWork = oSdkBusExpDtl.getSdkChargeDt();
        } else {
            stringWork = " not initilized";
        }
        System.out.println("  SDK_BUS_EXP_DTL   current active charge is dated : " + stringWork);
        System.out.println("  ===============");
        System.out.println("\t16) GetPropertyByName       17) GetPropertyInfoByName");
        System.out.println("\t18) Item                    19) InsertItem");
        System.out.println("\t20) DeleteItem              21) ItemByKeys");
        System.out.println("\t22) CurrentItem             23) CurrentItemNum");
        System.out.println("\t24) GetEffectiveItem        25) GetEffectiveItemNum");
        
        System.out.println("\t q) Quit");
        System.out.println("");
        System.out.print("Command to execute (1-25, q) [q]: ");
        
        stringWork = readLine();
        if (stringWork.length() ==0 || isQuit(stringWork)) {
            intWork = 0;
        } else {
            intWork = getIntValue(stringWork);
            if (intWork > 0 && intWork < 26) {
                return intWork;
            }
        }
        return 0;
    }
    
    /************************************************************************
     * Function:     executeMethod                                          *
     *                                                                      *
     * Description:  Execute selected method                                *
     *                                                                      *
     * Returns:      void                                                   *
     ***********************************************************************/
    private static void executeMethod(int nMethodIn) throws JOAException {
        int nMethod, nSdkBusExpPerCollCount, nSdkBusExpDtlCollCount, nSelectedBusExpPerRow;
        nMethod = 0;
        nSdkBusExpPerCollCount = 0;
        nSelectedBusExpPerRow = 0;
        boolean cReturn = false;
        char charExecute = ' ';
        String tempName = "";
        ISdkBusExpSdkBusExpPer tempPeriod = null;
        
        switch (nMethodIn) {
            case SDK_BUS_EXP_Save:
                //***** Execute Save *****
                oSdkBusExp.save();
                break;
                
            case SDK_BUS_EXP_Cancel:
                //***** Execute Cancel *****
                oSdkBusExp.cancel();
                oSdkBusExpPer = null;
                oSdkBusExpDtl = null;
                return;
            
            case SDK_BUS_EXP_GetPropertyByName:
                while (true) {
                    strTemp = getSdkBusExpPropertyName(0);
                    if (strTemp == null)
                        break;
                    System.out.println(strTemp + " value is " + oSdkBusExp.getPropertyByName(strTemp).toString());
                }
                break;
                
            case SDK_BUS_EXP_GetPropertyInfoByName:
                while (true) {
                    tempName = getSdkBusExpPropertyName(0);
                    if (tempName == null)
                        break;
                    oCompIntfcPropertyInfo = oSdkBusExp.getPropertyInfoByName(tempName);
                    printoutPropertyInfo(oCompIntfcPropertyInfo);
                }
                break;
                
            case SDK_BUS_EXP_InsertBusExpDtlDefaults:
                if (oSdkBusExp != null) {
                    //***** Execute Cancel *****
                    oSdkBusExp.cancel();
                }
                
                //***** Set Component Interface Get/Create Keys *****
                oSdkBusExp.setSdkEmplid(m_szGET_EMPLID);
                
                //***** Execute Get *****
                if (!oSdkBusExp.get()) {
                    System.out.println("Failed to Execute Get() for Insert on Component Interface " + m_strCIName);
                    return;
                }
                
                //***** Execute user defined method InsertBusExpDtlDefaults *****
                cReturn = oSdkBusExp.insertBusExpDtlDefaults(1);
                break;
                
            case SDK_BUS_EXP_PER_GetPropertyByName:
                if (oSdkBusExpPer == null) {
                    System.out.println("You must activiate an Expense period to use this function");
                } else {
                    while (true) {
                        strTemp = getSdkBusExpPropertyName(1);
                        if (strTemp == null)
                            break;
                        else {
                            System.out.println(strTemp + " value is " 
                                + oSdkBusExpPer.getPropertyByName(strTemp).toString());
                            System.out.println();
                        }
                    }
                }
                break;
            
            case SDK_BUS_EXP_PER_GetPropertyInfoByName:
                if (oSdkBusExpPer == null) {
                    System.out.println("You must activiate an Expense period to use this function");
                } else {
                    while (true) {
                        tempName = getSdkBusExpPropertyName(1);
                        if (tempName == null) 
                            break;
                        oCompIntfcPropertyInfo = oSdkBusExpPer.getPropertyInfoByName(tempName);
                        printoutPropertyInfo(oCompIntfcPropertyInfo);
                    }
                }
                break;
            
            case SDK_BUS_EXP_PER_Item:
                int tempInt = selectSdkBusExpPer();
                if (tempInt > 0) {
                    updateSdkBusExpPer(tempInt);
                    currentPeriod = tempInt;
                }
                break;
                
            case SDK_BUS_EXP_PER_InsertItem:
                insertSdkBusExpPer();
                break;
                
            case SDK_BUS_EXP_PER_DeleteItem:
                tempInt = selectSdkBusExpPer();
                if (tempInt > 0) {
                    if (oSdkBusExpPerCollection.deleteItem(tempInt - 1)) {
                        if (oSdkBusExp.save()) {
                            // print out the expense periods that are left. without the detalails.
                            getSdkBusExpPer(oSdkBusExp, false);
                            System.out.println("Expense Period number " + tempInt + " deleted succsessfully");
                            oSdkBusExpPer = null;
                        }
                        else {
                            System.out.println("Expense Period deletion of item " + tempInt + " failed");
                        }
                    }
                }
                break;
                
            case SDK_BUS_EXP_PER_ItemByKeys:
                break;
                
            case SDK_BUS_EXP_PER_CurrentItem:
                try {
                    if (oSdkBusExpPer == null)
                        System.out.println("You must activiate an Expense period to use this function");
                    else {
                        tempPeriod  = oSdkBusExpPerCollection.currentItem();
                        System.out.println("Current item set to " + oSdkBusExpPer.getItemNum());
                    }
                }
                catch(JOAException j) {
                    System.out.println("Current item not available for Component Interface  " + m_strCIName);
                }
                break;
            
            case SDK_BUS_EXP_PER_CurrentItemNum:
                try {
                    if (oSdkBusExpPer == null)
                        System.out.println("You must activiate an Expense period to use this function");
                    else {
                        if (oSdkBusExpPerCollection == null) break;
                        tempInt = (int)oSdkBusExpPerCollection.currentItemNum();
                        System.out.println("The Current Item number is " + tempInt);
                    }
                }
                catch(JOAException j) {
                    System.out.println("Current Item Number not available for Component Interface  " + m_strCIName);
                }
                break;
            
            case SDK_BUS_EXP_PER_GetEffectiveItem:
                try {
                    if (oSdkBusExpPer == null)
                        System.out.println("You must activiate an Expense period to use this function");
                    else {
                        //todo            oSdkBusExpPer = oSdkBusExpPerCollection.getEffectiveItem();
                        String tempDate = "12/11/2000";
                        long tempSeqNum = 1;
                        oSdkBusExpPer = oSdkBusExpPerCollection.getEffectiveItem(tempDate,tempSeqNum);
                        if (oSdkBusExpPer != null)
                            System.out.println("Current effective item is dated  " + oSdkBusExpPer.getSdkExpPerDt());
                        else
                            System.out.println("Component Interface " + m_strCIName + " is not effective dated.");
                    }
                }
                catch(JOAException j) {
                    System.out.println("Effective Item not available for Component Interface  " + m_strCIName);
                }
                break;
            
            case SDK_BUS_EXP_PER_GetEffectiveItemNum:
                try{
                    if (oSdkBusExpPer == null)
                        System.out.println("You must activiate an Expense period to use this function");
                    else {
                        //todo            tempInt = (int)oSdkBusExpPerCollection.getEffectiveItemNum();
                        String tempDate = "12/11/2000";
                        long tempSeqNum = 1;
                        tempInt = (int)oSdkBusExpPerCollection.getEffectiveItemNum(tempDate,tempSeqNum);
                        if (tempInt > 0)
                            System.out.println("The Effective Item Number is " + tempInt);
                        else
                            System.out.println("Component Interface " + m_strCIName + " is not effective dated.");
                    }
                }
                catch(JOAException j) {
                    System.out.println("Current item not available for Component Interface  " + m_strCIName);
                }
                break;
            
            case SDK_BUS_EXP_DTL_GetPropertyByName:
                if (oSdkBusExpDtl == null) {
                    System.out.println("You must activate an Expense Detail record to use this function");
                } else {
                    while (true) {
                        strTemp = getSdkBusExpPropertyName(2);
                        if (strTemp == null)
                            break;
                        else {
                            System.out.println(strTemp + " value is " 
                                + oSdkBusExpDtl.getPropertyByName(strTemp).toString());
                            System.out.println();

                        }
                    }
                }
                break;

            case SDK_BUS_EXP_DTL_GetPropertyInfoByName:
                if (oSdkBusExpDtl == null) {
                    System.out.println("You must activate an Expense Detail record to use this function");
                }
                else {
                    while (true) {
                        tempName = getSdkBusExpPropertyName(2);
                        if (tempName == null) break;
                        oCompIntfcPropertyInfo = oSdkBusExpDtl.getPropertyInfoByName(tempName);
                        printoutPropertyInfo(oCompIntfcPropertyInfo);
                    }
                }
                break;
            
            case SDK_BUS_EXP_DTL_Item:
                if (oSdkBusExpPer == null)
                    System.out.println("You must activiate an Expense period to use this function");
                else {
                    oSdkBusExpDtlCollection = oSdkBusExpPer.getSdkBusExpDtl();
                    tempInt = selectSdkBusExpDtl();
                    oSdkBusExpDtl = oSdkBusExpDtlCollection.item(tempInt -1);
                    updateSdkBusExpDtl(false);
                    currentDetail = tempInt;
                }
                break;

            case SDK_BUS_EXP_DTL_InsertItem:
                insertSdkBusExpDtl(1);
                break;

            case SDK_BUS_EXP_DTL_DeleteItem:
                if (oSdkBusExp == null) {
                    //***** Execute Cancel *****
                    oSdkBusExp.cancel();
                    //***** Set Component Interface Get/Create Keys *****
                    oSdkBusExp.setSdkEmplid(m_szGET_EMPLID);
                    //***** Execute Get *****
                    if (!oSdkBusExp.get()){
                        System.out.println("Failed to Get Component Interface %s." + m_strCIName);
                        return;
                    }
                }
                nSelectedBusExpPerRow = selectSdkBusExpPer();
                nSdkBusExpPerCollCount = (int)oSdkBusExpPerCollection.getCount();
                if (nSelectedBusExpPerRow >= 0 && nSelectedBusExpPerRow < nSdkBusExpPerCollCount)
                    deleteSdkBusExpDtl(nSelectedBusExpPerRow);
                break;
                
            case SDK_BUS_EXP_DTL_ItemByKeys:
                break;
                
            case SDK_BUS_EXP_DTL_CurrentItem:
                break;
                
            case SDK_BUS_EXP_DTL_CurrentItemNum:
                break;
            
            case SDK_BUS_EXP_DTL_GetEffectiveItem:
                break;
            
            case SDK_BUS_EXP_DTL_GetEffectiveItemNum:
                break;
        }
        return;
    }

    /************************************************************************
     * Function:     getSdkBusExpPropertyName                               *
     *                                                                      *
     * Description:  select property name from collection of properties     *
     *                                                                      *
     * Returns:      a string with the name selected by the user.           *
     ***********************************************************************/
    private static String getSdkBusExpPropertyName(int nLevel) throws JOAException {
        ICompIntfcPropertyInfoCollection oL0_PropInfoColl, oL1_PropInfoColl, oL2_PropInfoColl, otmpPropInfoColl;
        ICompIntfcPropertyInfo oL0_PropInfoItem, oL1_PropInfoItem, oL2_PropInfoItem;
        int nReturn;

        //***** Get the Meta data if the list is empty *****
        if (m_ciMetaData.isEmpty()) {
            //***** Get Level 0 Collection *****
            oL0_PropInfoColl = oSdkBusExp.getPropertyInfoCollection();
            for (int i = 0; i < oL0_PropInfoColl.getCount(); i++) {
                //***** Get Level 0 Properties *****
                oL0_PropInfoItem = oL0_PropInfoColl.item(i);
                m_ciMetaData.add(new ciPropertyInfo(0, oL0_PropInfoItem.getName(), oL0_PropInfoItem.getIsCollection()));
                if (oL0_PropInfoItem.getIsCollection()) {
                    //***** Get Level 1 Collection *****
                    oL1_PropInfoColl = oL0_PropInfoItem.getPropertyInfoCollection();
                    for (int j = 0; j < oL1_PropInfoColl.getCount(); j++) {
                        //***** Get Level 1 Properties *****
                        oL1_PropInfoItem = oL1_PropInfoColl.item(j);
                        m_ciMetaData.add(new ciPropertyInfo(1, oL1_PropInfoItem.getName(), oL1_PropInfoItem.getIsCollection()));
                        if (oL1_PropInfoItem.getIsCollection()) {
                            //***** Get Level 2 Collection *****
                            oL2_PropInfoColl = oL1_PropInfoItem.getPropertyInfoCollection();
                            for (int k = 0; k < oL2_PropInfoColl.getCount(); k++) {
                                //***** Get Level 0 Properties *****
                                oL2_PropInfoItem = oL2_PropInfoColl.item(k);
                                m_ciMetaData.add(new ciPropertyInfo(2, oL2_PropInfoItem.getName(), oL2_PropInfoItem.getIsCollection()));
                            }
                        }
                    }
                }
            }
        }
        System.out.println("Select property name you want info about.");
        
        ciPropertyInfo tempPropertyInfo;
        int j = 0;
        List tempList = new ArrayList();
        for (int i = 0; i < m_ciMetaData.size(); i++) {
            tempPropertyInfo = (ciPropertyInfo)m_ciMetaData.get(i);
            if (nLevel == tempPropertyInfo.m_nLevel && !(tempPropertyInfo.m_isCollection)) {
                j++;
                System.out.println("\t" + j + ": " + tempPropertyInfo.m_PropertyName);
                tempList.add(tempPropertyInfo.m_PropertyName);
            }
        }
        System.out.print("Select one (1-" + j + ", q) [1]: ");
        
        strTemp = readLine();
        if (strTemp.length() == 0) {
            nReturn = 1;
        } else {
            if (isQuit(strTemp)) {
                return null;
            } else {
                nReturn = getIntValue(strTemp);
            }
        }
        
        if (nReturn == 0 || nReturn > j)
            nReturn = 1;
        return (String)tempList.get(nReturn - 1);
    }

    /************************************************************************
     * Function:     printoutPropertyInfo                                   *
     *                                                                      *
     * Description:  Print the property info for the selected property      *
     *                                                                      *
     * Returns:      void                                                   *
     ***********************************************************************/
    private static void printoutPropertyInfo(ICompIntfcPropertyInfo oICIPInfo) throws JOAException {
        String[] typeArray = {"Character","Long Character","Number","Signed Number","Date","Time","Date Time","SubRecord","Image","ImageReference"};
        System.out.println(oICIPInfo.getName());
        if (!oICIPInfo.getIsCollection()) {
            System.out.println("\t Format = " + oICIPInfo.getFormat());
            System.out.println("\t Type = " + typeArray[(int)oICIPInfo.getType()]);
        }
        System.out.println("\t Is Required = " + oICIPInfo.getRequired());
        System.out.println("\t Is Collection? = " + oICIPInfo.getIsCollection());
        System.out.println("\t Is Read Only? = " + oICIPInfo.getIsReadOnly());
        System.out.println("\t Is Get Key? = " + oICIPInfo.getKey());
        System.out.println("\t Label Long = " + oICIPInfo.getLabelLong());
        System.out.println("\t Label Short = " + oICIPInfo.getLabelShort());
        System.out.println("\t Length = " + oICIPInfo.getLength());
        System.out.println("\t Name = " + oICIPInfo.getName());
        System.out.println("\t Is Xlat? = " + oICIPInfo.getXlat());
        System.out.println("\t Is Yesno? = " + oICIPInfo.getYesno());
    }

    /************************************************************************
     * Function:     getConnectParameters                                   *
     *                                                                      *
     * Description:  Get Connect Parameters from user                       *
     *                                                                      *
     * Returns:      false is connect information not provided; else true   *
     ***********************************************************************/
    private static boolean getConnectParameters() {
        try {
            //***** Get the Application Server Machine Name *****
            System.out.println("Application Server Connect Information... ");
            System.out.print("Enter The Application Server Machine Name [" + m_strServerName + "]: ");
            m_strServerName = readLine();
            
            //***** Get the Application Server Port Number *****
            System.out.print("Enter The Application Server Port Number [" + m_strServerPort + "]: ");
            strTemp = readLine();
            if (strTemp.length() > 0)
                m_strServerPort = strTemp;
            
            //***** Get PeopleSoft UserID *****
            System.out.print("Enter PeopleSoft UserID [" + m_strUserID + "]: ");
            strTemp = readLine();
            if (strTemp.length() > 0)
                m_strUserID = strTemp;
            
            //***** Get PeopleSoft UserID Password *****
            System.out.print("Enter PeopleSoft UserID Password [" + m_strUserPswd + "]: ");
            strTemp = readLine();
            if (strTemp.length() > 0)
                m_strUserPswd = strTemp;
            
            if (m_strServerName.length() == 0 ||
                m_strServerPort.length() == 0 ||
                m_strUserID.length() == 0 ||
                m_strUserPswd.length() == 0) {
                return false;
            }
            
            //Build the Application Server Path
            m_strAppServerPath = m_strServerName + ":" + m_strServerPort;
        }
        catch (Exception e) {
            e.printStackTrace();
            return false;
        }
        return true;
    }

    /************************************************************************
     * Function:     connectToAppServer                                     *
     *                                                                      *
     * Description:  Connect to the Application Server                      *
     *                                                                      *
     * Returns:      false when unable to connect to app server; else true  *
     ***********************************************************************/
    private static boolean connectToAppServer() {
        try {
            boolean bReturn = false;
            
            //***** Create PeopleSoft Session Object *****
            oSession = API.createSession();
            
            //***** Connect to the App Sever *****
            if (oSession.connect(1, m_strAppServerPath, m_strUserID, m_strUserPswd, null)) {
                bReturn = true;
                //               System.out.println("Connect to Application Server succeeded...");
                System.out.println("");
            }
            else {
                System.out.println("Connect to Application Server failed...");
                System.out.println("Possible causes for this error are: ");
                System.out.println("1. CLASSPATH environment variable not set properly - ");
                System.out.print("psjoa.jar should be included in the CLASSPATH");
                System.out.println("2. APIs are not built");
                System.out.println("3. Connect Information to the Application Server is incorrect");
                System.out.println("4. Application Server not running");
                System.out.println("Check the Application Server log files for additional messages.");
                errorHandler();
                return false;
            }
            return bReturn;
        }
        catch (Exception e) {
            errorHandler();
            e.printStackTrace();
        }
        return false;
    }

    /************************************************************************
     * Function:     disconnectFromAppServer                                *
     *                                                                      *
     * Description:  Disconnect from the Application Server                 *
     *                                                                      *
     * Returns:      void                                                   *
     ***********************************************************************/
    private static void disconnectFromAppServer() {
        try {
            if (oSession != null)
                oSession.disconnect();
        }
        catch (Exception e) {
            errorHandler();
            e.printStackTrace();
        }
    }

    /************************************************************************
     * Function:     getGetKeys                                             *
     *                                                                      *
     * Description:  Get Get Keys                                           *
     *                                                                      *
     * Returns:      false if no Get Keys provided; else true               *
     ***********************************************************************/
    private static boolean getGetKeys() {
        //***** Prompt for the Employee ID *****
        System.out.print("Enter Employee ID: ");
        m_szGET_EMPLID = readLine();
        
        //***** Validate the Get Keys *****
        if (m_szGET_EMPLID.length() != 0  && m_szGET_EMPLID.charAt(0) != ' ') {
            return true;
        } else {
            System.out.println("No Get Key provided.");
            return false;
        }
    }

    /************************************************************************
     * Function:     getFindKeys                                            *
     *                                                                      *
     * Description:  Get Find Keys                                          *
     *                                                                      *
     * Returns:      false if no Find Keys provided; else true              *
     ***********************************************************************/
    private static boolean getFindKeys() {
        String[] tmpArray = {"Employee ID","Employee Name","Employee Last Name"};
        String   tmpKeyValue;

        System.out.println("Search for Employees...");
        for (int i = 0, nTemp = 0; i < tmpArray.length; i++) {
            System.out.print("Enter " + tmpArray[i]);
            if (i > 0) {
                System.out.print(" (optional)");
            }
            System.out.print(": ");
            tmpKeyValue = readLine();
            if (tmpKeyValue.length() > 0 && tmpKeyValue.charAt(0) != ' ') {
                System.out.println("Does " + tmpArray[i] + ":");
                System.out.println("\t1) Begin With " + tmpKeyValue  + " or ");
                System.out.println("\t2) Contain " + tmpKeyValue + " ?");
                System.out.print("Enter Selection (1-2) [1]: ");
                strTemp = readLine();
                if (strTemp.length() > 0 && strTemp.charAt(0) != ' ') {
                    nTemp = Character.digit(strTemp.charAt(0),9);
                    if (nTemp < 1 && nTemp > 2) {
                        nTemp = 1;
                    }
                }
            }
            switch(i) {
                case 0:
                    m_szFIND_EMPLID = tmpKeyValue;
                    m_nFIND_EMPLID = nTemp;
                    break;
                case 1:
                    m_szFIND_NAME = tmpKeyValue;
                    m_nFIND_NAME = nTemp;
                    break;
                case 2:
                    m_szFIND_LAST_NAME_SRCH = tmpKeyValue;
                    m_nFIND_LAST_NAME_SRCH = nTemp;
            }
        }

        //***** Validate the Find Keys *****
        if ((m_szFIND_EMPLID.length() > 0 && m_szFIND_EMPLID.charAt(0) != ' ') ||
            (m_szFIND_NAME.length() > 0 && m_szFIND_NAME.charAt(0) != ' ') ||
            (m_szFIND_LAST_NAME_SRCH.length() > 0 && m_szFIND_LAST_NAME_SRCH.charAt(0) != ' ')) {
            return true;
        }
        else {
            System.out.println("No Find Key provided.");
            return false;
        }
    }

    /************************************************************************
     * Function:     buildFindKeys                                          *
     *                                                                      *
     * Description:  Build Find keys depending on the selection             *
     *                                                                      *
     * Returns:      void                                                   *
     ***********************************************************************/
    private static void buildFindKeys() {
        for (int i = 0; i < 3; i++) {
            switch (i) {
                case 0:
                    //***** Format EMPLID Find Key *****
                    if (m_szFIND_EMPLID.length() > 0 && m_nFIND_EMPLID == 2) {
                        m_szFIND_EMPLID = "%" + m_szFIND_EMPLID + "%";
                    }
                    break;
                case 1:
                    //***** Format SEARCH_NAME Find Key *****
                    if (m_szFIND_NAME.length() > 0 && m_nFIND_NAME == 2) {
                        m_szFIND_NAME = "%" + m_szFIND_NAME + "%";
                    }
                    break;
                case 2:
                    //***** Format SEARCH_LAST_NAME_SRCH Find Key *****
                    if (m_szFIND_LAST_NAME_SRCH.length() > 0 && m_nFIND_LAST_NAME_SRCH == 2) {
                        m_szFIND_LAST_NAME_SRCH = "%" + m_szFIND_LAST_NAME_SRCH + "%";
                    }
                    break;
            }
        }
    }

    /************************************************************************
     * Function:     getFindResults                                         *
     *                                                                      *
     * Description:  Gets rows for the provided Find Keys                   *
     *                                                                      *
     * Returns:      false if no rows found; else true                      *
     ***********************************************************************/
    private static boolean getFindResults() throws JOAException {
        String workString = "";
        
        if (oSdkBusExp == null){
            System.out.println("Invalid Component Interface.");
            disconnectFromAppServer();
            return false;
        }
        
        //***** Set required keys to FIND the component *****
        oSdkBusExp.setSdkEmplid(m_szFIND_EMPLID);
        oSdkBusExp.setSdkName(m_szFIND_NAME);
        oSdkBusExp.setSdkLastNameSrch(m_szFIND_LAST_NAME_SRCH);
        
        //***** Get the collection and number of rows within it *****
        oSdkBusExpCollection = oSdkBusExp.find();
        if(oSdkBusExpCollection == null) {
            System.out.println("No rows found.");
            return false;
        }
        
        int nSdkEmplidCol, nSdkNameCol, nSdkLastNameSrchCol;
        nSdkEmplidCol = 35;
        nSdkNameCol = 25;
        nSdkLastNameSrchCol = 35;

        //***** Output the Name and Employee ID for the current collection *****
        System.out.print(formatString("Employee Number", nSdkEmplidCol));
        System.out.print(formatString("Name"           , nSdkNameCol));
        System.out.print(formatString("Last Name"      , nSdkLastNameSrchCol));
        System.out.println("");
        System.out.print(formatString("===============", nSdkEmplidCol));
        System.out.print(formatString("===="           , nSdkNameCol));        
        System.out.print(formatString("========="      , nSdkLastNameSrchCol));
        System.out.println("");
        
        ISdkBusExp oSdkBusExpCollectionItem;
        for (int i = 0; i < oSdkBusExpCollection.getCount(); i++) {
            oSdkBusExpCollectionItem =  oSdkBusExpCollection.item(i);
            workString = oSdkBusExpCollectionItem.getSdkEmplid();
            System.out.print(formatString(workString, nSdkEmplidCol));
            workString = oSdkBusExpCollectionItem.getSdkName();
            System.out.print(formatString(workString, nSdkNameCol));
            workString = oSdkBusExpCollectionItem.getSdkLastNameSrch();
            System.out.print(formatString(workString, nSdkLastNameSrchCol));
            System.out.println("");
        }
        return true;
    }

    /************************************************************************
     * Function:     selectSdkBusExpPer                                     *
     *                                                                      *
     * Description:  select an existing Business Expense Period             *
     *                                                                      *
     * Returns:      int: number of selected Business Expense Period        *
     ***********************************************************************/
    private static int selectSdkBusExpPer() throws JOAException {
        int nReturn = -1;

        if (oSdkBusExp != null) {
            nReturn = getSdkBusExpPer(oSdkBusExp, false);
            System.out.print("Select Expense Period to work with 1 to " + nReturn + ": ");
            nReturn = getIntValue(readLine());
            oSdkBusExpPerCollection = oSdkBusExp.getSdkBusExpPer();
            if (!(nReturn > 0 && nReturn <= oSdkBusExpPerCollection.getCount()))
                nReturn = -1;
        }
        return nReturn;
    }

    /************************************************************************
     * Function:     selectSdkBusExpDtl                                     *
     *                                                                      *
     * Description:  select an existing Business Expense Period             *
     *                                                                      *
     * Returns:      int: number of selected Business Expense Period        *
     ***********************************************************************/
    private static int selectSdkBusExpDtl() throws JOAException {
        int tempInt = getSdkBusExpDtl(oSdkBusExpPer, false);
        System.out.print("Select Expense Detail to work with 1 to " + tempInt + ": ");
        tempInt = getIntValue(readLine());
        return tempInt;
    }

    /************************************************************************
     * Function:     getSdkBusExpDtl                                        *
     *                                                                      *
     * Description:  Get Business Expense Details for selected Business     *
     *               Expense Periods                                        *
     *                                                                      *
     * Returns:      number of business expense details                     *
     ***********************************************************************/
    private static int getSdkBusExpDtl(ISdkBusExpSdkBusExpPer oInSdkBusExpPer, boolean withDetails) throws JOAException {
        //***** By using a work copy of the expense period record, we leave the active record intact *****
        ISdkBusExpSdkBusExpPerSdkBusExpDtl detailLocal;
        float   nAmt;
        int     nSdkBusExpDtlCollCount;
        String  padString;
        String  pszTemp;
        
        nSdkBusExpDtlCollCount = 0;
        if (withDetails) {
            padString = "";
        } else {
            padString = "\t";
        }
        oSdkBusExpDtlCollection = oInSdkBusExpPer.getSdkBusExpDtl();
        nSdkBusExpDtlCollCount = (int)oSdkBusExpDtlCollection.getCount();
        int nSdkChargeDtCol, nSdkExpenseCdCol, nSdkExpenseAmtCol, nSdkBusPurposeCol, nSdkDeptidCol;
        nSdkChargeDtCol   = 16;
        nSdkExpenseCdCol  = 18;
        nSdkExpenseAmtCol = 20;
        nSdkBusPurposeCol = 22;
        nSdkDeptidCol     = 10;
        System.out.print(padString);
        System.out.print(formatString("Charge Dt."      , nSdkChargeDtCol));
        System.out.print(formatString("Expense Code"    , nSdkExpenseCdCol));
        System.out.print(formatString("Expense Amount"  , nSdkExpenseAmtCol));
        System.out.print(formatString("Business Purpose", nSdkBusPurposeCol));
        System.out.println(formatString("Department"    , nSdkDeptidCol));
        System.out.print(padString);        
        System.out.print(formatString("=========="      , nSdkChargeDtCol));
        System.out.print(formatString("============"    , nSdkExpenseCdCol));
        System.out.print(formatString("=============="  , nSdkExpenseAmtCol));
        System.out.print(formatString("================", nSdkBusPurposeCol));
        System.out.println(formatString("=========="    , nSdkDeptidCol));
        for (int i = 0; i < nSdkBusExpDtlCollCount; i++) {
            if (!withDetails) {
                padString = (i+1) + ") \t";
                System.out.print(padString);
            }
            detailLocal =oSdkBusExpDtlCollection.item(i);
            pszTemp = detailLocal.getSdkChargeDt();
            System.out.print(formatString(pszTemp, nSdkChargeDtCol));
            pszTemp = detailLocal.getSdkExpenseCd();
            System.out.print(formatString(pszTemp, nSdkExpenseCdCol));
            pszTemp = detailLocal.getSdkExpenseAmt().toString();
            System.out.print(formatString(pszTemp, nSdkExpenseAmtCol));
            pszTemp = detailLocal.getSdkBusPurpose();
            System.out.print(formatString(pszTemp, nSdkBusPurposeCol));
            pszTemp = detailLocal.getSdkDeptid();
            System.out.println(formatString(pszTemp, nSdkDeptidCol));
        }
        return nSdkBusExpDtlCollCount;
    }

    /************************************************************************
     * Function:     getSdkBusExpPer                                        *
     *                                                                      *
     * Description:  Get Business Expense Periods for selected employee     *
     *                                                                      *
     * Returns:      number of business expense periods                     *
     ***********************************************************************/
    private static int getSdkBusExpPer(ISdkBusExp oSdkBusExp, boolean withDetails) throws JOAException {
        //**** By using a work copy of the expense period record, we leave the active record intact *****
        ISdkBusExpSdkBusExpPer oSdkBusExpPerLocal;
        float   nAmt;
        int     nSdkBusExpPerCollCount, nSdkBusExpDtlCollCount;
        String pszTemp;
        
        nSdkBusExpPerCollCount = 0;
        
        //***** Get the Business Expense Period *****
        oSdkBusExpPerCollection = oSdkBusExp.getSdkBusExpPer();
        nSdkBusExpPerCollCount = (int)oSdkBusExpPerCollection.getCount();
        if (nSdkBusExpPerCollCount < 1) {
            System.out.println("No Business Expenses found for Employee...");
            return 0;
        }
        
        for (int i = 0; i < nSdkBusExpPerCollCount; i++) {
            oSdkBusExpPerLocal = oSdkBusExpPerCollection.item(i);
            System.out.println("Expense Period Number: " + (i + 1));
            pszTemp = oSdkBusExpPerLocal.getSdkExpPerDt();
            System.out.println("\tExpense Period End Date: " + pszTemp);
            pszTemp = oSdkBusExpPerLocal.getSdkBusExpSum().toString();
            System.out.println("\tExpense Period Total: " + pszTemp);
            if (withDetails) {
                //***** Get the Business Expense Details
                nSdkBusExpDtlCollCount = getSdkBusExpDtl(oSdkBusExpPerLocal,true);
            }
            System.out.println("");
        }
        return nSdkBusExpPerCollCount;
    }

    /************************************************************************
     * Function:     updateSdkBusExpPer                                     *
     *                                                                      *
     * Description:  Update Business Expense Period for for selected        *
     *               employee                                               *
     *                                                                      *
     * Returns:      void                                                   *
     ***********************************************************************/
    private static void updateSdkBusExpPer(int nSelectedBusExpPerRow) throws JOAException {
        //***** Execute Cancel *****
        oSdkBusExp.cancel();
        
        //***** Set Component Interface Get/Create Keys *****
        oSdkBusExp.setSdkEmplid(m_szGET_EMPLID);
        
        //***** Execute Get *****
        if (!oSdkBusExp.get()) {
            System.out.println("Failed to Get Component Interface " + m_strCIName);
            return;
        }        
        oSdkBusExpPerCollection = oSdkBusExp.getSdkBusExpPer();
        oSdkBusExpPer = oSdkBusExpPerCollection.item(nSelectedBusExpPerRow - 1);        
        strTemp = oSdkBusExpPer.getSdkExpPerDt();
        System.out.println("Expense Period End Date: " + strTemp);
        System.out.println("Expense Period Total:   " + oSdkBusExpPer.getSdkBusExpSum());
        
        boolean bSaveChanges = false;
        //***** Get the new Expense Period End Date ***** 
        System.out.print("Enter new Expense Period End Date [" + strTemp + "]: ");
        strTemp = "";
        strTemp = readLine();
        if (strTemp.length() > 0 && strTemp.charAt(0) != ' ') {
            oSdkBusExpPer.setSdkExpPerDt(strTemp);
            bSaveChanges = true;
        }

        if (bSaveChanges) {
            //***** Execute Save *****
            if (oSdkBusExp.save()){
                System.out.println("Changes saved successfully!!!");
                System.out.println("New Expense Period is " + strTemp);                
            }
            else {
                System.out.println("Error saving changes...");
                errorHandler();
                return;
            }
        }
    }

    /************************************************************************
     * Function:     insertSdkBusExpPer                                     *
     *                                                                      *
     * Description:  Insert Business Expense Period for the selected        *
     *               employee                                               *
     *                                                                      *
     * Returns:      void                                                   *
     ***********************************************************************/
    private static void insertSdkBusExpPer() throws JOAException {
        String szExpensePer = "";
        //***** Execute Cancel *****
        oSdkBusExp.cancel();
        
        //***** Set Component Interface Get/Create Keys *****
        oSdkBusExp.setSdkEmplid(m_szGET_EMPLID);
        
        //***** Execute Get *****
        if (!oSdkBusExp.get()) {
            System.out.println("Failed to Get Component Interface " + m_strCIName);
            return;
        }
        oSdkBusExpPerCollection = oSdkBusExp.getSdkBusExpPer();
        
        // the new period is inserted as the last element.
        oSdkBusExpPer = oSdkBusExpPerCollection.insertItem(oSdkBusExpPerCollection.getCount() - 1);
        if (oSdkBusExpPer == null)
            return;
        
        //***** Get the Date for the expense period. *****
        System.out.print("\t Enter Expense Period Date : ");
        szExpensePer = readLine();
        if (szExpensePer.length() > 0 ) {
            oSdkBusExpPer.setSdkExpPerDt(szExpensePer);
            if (oSdkBusExp.save()) {
                System.out.println("Changes saved successfully!!!");
            } else {
                System.out.println("Error saving changes...");
                errorHandler();
                return;
            }
        }
        else {
            System.out.println("Required Fields not provided.");
        }
    }

    /************************************************************************
     * Function:     updateSdkBusExpDtl                                     *
     *                                                                      *
     * Description:  Update Business Expense Details for given Business     *
     *               Expense Period                                         *
     *                                                                      *
     * Returns:      void                                                   *
     ***********************************************************************/
    private static void updateSdkBusExpDtl(boolean isNew) throws JOAException {
        float    fAmt;       
        if (oSdkBusExpDtl == null) {
            System.out.println("A detail record must be selected before this function");
            return;
        }
        
        //***** Display SDK_BUS_EXP_PER properties *****
        strTemp = oSdkBusExpPer.getSdkExpPerDt();
        System.out.println("Expense Period End Date: " + strTemp);
        strTemp = oSdkBusExpPer.getSdkBusExpSum().toString();
        System.out.println("Expense Period Total:   " + strTemp);        
        
        boolean bSaveChanges = false;
        //***** Get Charge Date *****
        if (!isNew)
            strTemp = oSdkBusExpDtl.getSdkChargeDt();
        else
            strTemp = "";
        System.out.print("\t Enter Charge Dt.[" + strTemp + "]: ");
        strTemp = readLine();
        if (strTemp.length() > 0 && strTemp.charAt(0) != ' ') {
            oSdkBusExpDtl.setSdkChargeDt(strTemp);
            bSaveChanges = true;        
        }
        
        //***** Get Expense Code *****
        if (!isNew) {
            strTemp = oSdkBusExpDtl.getSdkExpenseCd();
        } else {
            strTemp = "";
        }
        System.out.print("\t Enter Expense Code[" + strTemp + "]: ");
        strTemp = readLine();
        if (strTemp.length() > 0 && strTemp.charAt(0) != ' ') {
            oSdkBusExpDtl.setSdkExpenseCd(strTemp);
            bSaveChanges = true;
        }
        
        //***** Get Expense Amount *****
        if (!isNew) {
            strTemp = oSdkBusExpDtl.getSdkExpenseAmt().toString();
        } else {
            strTemp = "0";
        }
        System.out.print("\t Enter Expense Amount[" + strTemp + "]: ");
        strTemp = readLine();
        if (strTemp.length() > 0 && strTemp.charAt(0) != ' ') {
            BigDecimal d = new BigDecimal(strTemp);
            oSdkBusExpDtl.setSdkExpenseAmt(d);
            bSaveChanges = true;
        }
        
        //***** Get Business Purpose *****
        if (!isNew)
            strTemp = oSdkBusExpDtl.getSdkBusPurpose();
        else strTemp = "";
        System.out.print("\t Enter Business Purpose[" + strTemp + "]: ");
        strTemp = readLine();
        if (strTemp.length() > 0 && strTemp.charAt(0) != ' ') {
            oSdkBusExpDtl.setSdkBusPurpose(strTemp);
            bSaveChanges = true;
        }
        
        //***** Get Department ID *****
        if (!isNew)
            strTemp = oSdkBusExpDtl.getSdkDeptid();
        else strTemp = "";
        System.out.print("\t Enter Department ID[" + strTemp + "]: ");
        strTemp = readLine();
        if (strTemp.length() > 0 && strTemp.charAt(0) != ' ') {
            oSdkBusExpDtl.setSdkDeptid(strTemp);
            bSaveChanges = true;
        }
        
        if (bSaveChanges) {
            if (oSdkBusExp.save())
                System.out.println("Changes saved successfully!!!");
            else{
                System.out.println("Error saving changes...");
                errorHandler();
            }
        }
        return;
    }

    /************************************************************************
     * Function:     insertSdkBusExpDtl                                     *
     *                                                                      *
     * Description:  Insert Business Expense Details for given Business     *
     *               Expense Period                                         *
     *                                                                      *
     * Returns:      void                                                   *
     ***********************************************************************/
    private static void insertSdkBusExpDtl(int nSelectedBusExpPerRow) throws JOAException {
        float    nAmt;
        
        //***** Execute Cancel *****
        oSdkBusExp.cancel();
        //***** Set Component Interface Get/Create Keys *****
        oSdkBusExp.setSdkEmplid(m_szGET_EMPLID);
        //***** Execute Get *****
        if (!oSdkBusExp.get()) {
            System.out.println("Failed to Get Component Interface " + m_strCIName);
            return;
        }
        nSelectedBusExpPerRow = selectSdkBusExpPer();
        if (nSelectedBusExpPerRow > 0) {
            oSdkBusExpPer = oSdkBusExpPerCollection.item(nSelectedBusExpPerRow - 1);
            System.out.println("Expense Period Number: " + nSelectedBusExpPerRow);
            strTemp = oSdkBusExpPer.getSdkExpPerDt();
            System.out.println("\t Expense Period End Date: " + strTemp);
            strTemp = oSdkBusExpPer.getSdkBusExpSum().toString();
            System.out.println("\t Expense Period Total: " + strTemp );
            
            oSdkBusExpDtlCollection = oSdkBusExpPer.getSdkBusExpDtl();
            
            //***** Insert a row in Business Expense Detail. Inserted row is always the last one. *****
            int nSdkBusExpDtlCollCount = (int)oSdkBusExpDtlCollection.getCount();
            oSdkBusExpDtl = oSdkBusExpDtlCollection.insertItem(nSdkBusExpDtlCollCount - 1);
            if (oSdkBusExpDtl == null)
                return;
            updateSdkBusExpDtl(true);
        }
    }

    /************************************************************************
     * Function:     deleteSdkBusExpDtl                                     *
     *                                                                      *
     * Description:  Delete Business Expense Details for given Business     *
     *               Expense Period                                         *
     *                                                                      *
     * Returns:      void                                                   *
     ***********************************************************************/
    private static void deleteSdkBusExpDtl(int nSelectedBusExpPerRow) throws JOAException {
        float   nAmt;
        int     nBusExpDtlRow, nSdkBusExpDtlCollCount;
        
        //***** Execute Cancel *****
        oSdkBusExp.cancel();
        
        //***** Set Component Interface Get/Create Keys *****
        oSdkBusExp.setSdkEmplid(m_szGET_EMPLID);
        
        //***** Execute Get *****
        if (!oSdkBusExp.get()) {
            System.out.println("Failed to Get Component Interface " + m_strCIName + " for Delete function");
            return;
        }
    
        oSdkBusExpPerCollection = oSdkBusExp.getSdkBusExpPer();
        oSdkBusExpPer = oSdkBusExpPerCollection.item(nSelectedBusExpPerRow - 1);
        
        System.out.println("Expense Period Number: " + nSelectedBusExpPerRow);
        strTemp = oSdkBusExpPer.getSdkExpPerDt();
        System.out.println("  Expense Period End Date: " + strTemp);
        strTemp  = oSdkBusExpPer.getSdkBusExpSum().toString();
        System.out.println("  Expense Period Total: " + strTemp );
        
        //***** List all the Business Expense Details that can be deleted *****
        nSdkBusExpDtlCollCount = getSdkBusExpDtl(oSdkBusExpPer,true);
    
        //***** Get handle to the Business Expense Detail Collection *****
        oSdkBusExpDtlCollection = oSdkBusExpPer.getSdkBusExpDtl();
    
        nBusExpDtlRow = 1;
        System.out.println("Select Business Expense Detail to Delete (1-"
            + nSdkBusExpDtlCollCount + " [" + nBusExpDtlRow + "]:");
        strTemp = readLine();
        if (isQuit(strTemp))
            return;
        nBusExpDtlRow = getIntValue(strTemp);
    
        if (nBusExpDtlRow > 0 && nBusExpDtlRow <= nSdkBusExpDtlCollCount) {
            if (oSdkBusExpDtlCollection.deleteItem(nBusExpDtlRow - 1)) {
                if (oSdkBusExp.save()) {
                    //***** Get handle to the Business Expense Detail Collection *****
                    nSdkBusExpDtlCollCount = getSdkBusExpDtl(oSdkBusExpPer, true);
                    System.out.println("Row Deleted and Changes saved successfully!!!");
                }
                else {
                    System.out.println("Error saving changes...");
                    errorHandler();
                    return;
                }
            }
        }
        else {
            System.out.println("Invalid Business Expense Row");
        }
    }

    /************************************************************************
     * Function:     main                                                   *
     *                                                                      *
     * Description:  main                                                   *
     *                                                                      *
     * Returns:      void                                                   *
     ***********************************************************************/
    public static final void main(String[] args) {
        char charTemp = ' ';
        int methodInt = 0, functionInt = 0;
        //***** Initialize *****
        try {
            init();
            while (charTemp != 'q' && charTemp != 'Q') {
                System.out.println();
                System.out.println("----------------------------------------------------- ");
                System.out.println("PeopleSoft SDK Business Expense for Java - Main Menu  ");
                System.out.println("----------------------------------------------------- ");
                System.out.println("  ");
                System.out.println("\t 1) Sign In  ");
                System.out.println("\t q) Quit ");
                System.out.println("  ");
                System.out.print("Command to execute (1, q) [1]: ");
                charTemp = readCharacter();
            
                switch (charTemp) {
                    case 'q':
                    case 'Q':
                        //***** Disconnect From AppServer *****
                        disconnectFromAppServer();
                        return;
                    default:
                        //***** Sign In - Get Connect Parameters *****
                        getConnectParameters();
                        //***** Connect to the App Sever *****
                        if (connectToAppServer()) {
                            //***** Get an instance of the Component Interface *****
                            oSdkBusExp = (ISdkBusExp) oSession.getCompIntfc(m_strCIName);
                            if (oSdkBusExp == null) {
                                System.out.println("GetCompIntfc on " +  m_strCIName + " failed... ");
                                errorHandler();
                                disconnectFromAppServer();
                                return;
                            }

                            //***** Get input keys and execute "Get" or "Find"
                            while (getKeyType()) {
                                methodInt = selectMethod();
                                while (methodInt != 0) {
                                    executeMethod(methodInt);
                                    if (methodInt == 2) {
                                        methodInt = 0;
                                    } else {
                                        methodInt = selectMethod();
                                    }
                                }
                            }
                        }
                } //End Switch
            } //End While
        } catch (JOAException j) {
            System.out.println("Error in JOA processing: " + j.getMessage());
            j.printStackTrace();
        }
        return;
    }
}
